
#property copyright "Shahrooz Sadeghi"
#property link      "sh.sadeghi.me@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Orange

extern int TimeFrame = 0;
extern string Mail = "sh.sadeghi.me@gmail.com";
int Gi_88 = 4;
int Gi_92 = 10;
double Gda_96[];
double Gda_100[];
double Gda_104[];
double Gda_108[];

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   string Ls_0;
   string Ls_12;
   switch (TimeFrame) {
   case 1:
      Ls_12 = "Period_M1";
      break;
   case 5:
      Ls_12 = "Period_M5";
      break;
   case 15:
      Ls_12 = "Period_M15";
      break;
   case 30:
      Ls_12 = "Period_M30";
      break;
   case 60:
      Ls_12 = "Period_H1";
      break;
   case 240:
      Ls_12 = "Period_H4";
      break;
   case 1440:
      Ls_12 = "Period_D1";
      break;
   case 10080:
      Ls_12 = "Period_W1";
      break;
   case 43200:
      Ls_12 = "Period_MN1";
      break;
   default:
      Ls_12 = "Current Timeframe";
   }
   IndicatorShortName("MTF_$hah Osc ( " + Ls_12 + " ) ");
   IndicatorBuffers(3);
   SetIndexBuffer(0, Gda_96);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexLabel(0, "Bullish  [" + TimeFrame + "]");
   SetIndexBuffer(1, Gda_100);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexLabel(1, "Bearish  [" + TimeFrame + "]");
   SetIndexBuffer(2, Gda_104);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexLabel(2, "Neutral  [" + TimeFrame + "]");
   return (0);
}
		 		   	 		 	 		 	 	 		  						 	 		  			  	  	 		   	 	  		 	  	   		 	 	 		 		 	  		   		 	       								 				  		 	 	  			 		 		 	  	      	
// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int Lia_0[];
   double Ld_4;
   int Li_12;
   int Li_28 = 0;
   int Li_32 = IndicatorCounted();
   ArrayCopySeries(Lia_0, 5, Symbol(), TimeFrame);
   int Li_24 = Bars - Li_32;
   int Li_16 = 0;
   for (Li_28 = 0; Li_16 < Li_24; Li_16++) {
      if (Time[Li_16] < Lia_0[Li_28]) Li_28++;
      Ld_4 += Close[Li_16];
      Li_12++;
      Gda_108[Li_16] = Ld_4 / Li_12;
      if (Close[Li_16] > iMA(Symbol(), TimeFrame, Gi_88, 0, MODE_SMA, PRICE_HIGH, Li_28 + 1)) {
         Gda_96[Li_16] = 2184.0 * (Close[Li_16] - iMA(Symbol(), TimeFrame, Gi_88, 0, MODE_SMA, PRICE_HIGH, Li_28 + 1)) / ((Close[Li_16] + Close[Li_16] + High[Li_16] + Low[Li_16] +
            Open[Li_16]) / 5.0);
         Gda_100[Li_16] = 0;
         Gda_104[Li_16] = 0;
      } else {
         if (Close[Li_16] < iMA(Symbol(), TimeFrame, Gi_88, 0, MODE_SMA, PRICE_LOW, Li_28 + 1)) {
            Gda_96[Li_16] = 0;
            Gda_100[Li_16] = 2184.0 * (Close[Li_16] - iMA(Symbol(), TimeFrame, Gi_88, 0, MODE_SMA, PRICE_HIGH, Li_28 + 1)) / ((Close[Li_16] + Close[Li_16] + High[Li_16] + Low[Li_16] +
               Open[Li_16]) / 5.0);
            Gda_104[Li_16] = 0;
         } else {
            Gda_96[Li_16] = 0;
            Gda_100[Li_16] = 0;
            Gda_104[Li_16] = 2184.0 * (Close[Li_16] - (iMA(Symbol(), TimeFrame, Gi_88, 0, MODE_SMA, PRICE_HIGH, Li_28 + 1) + iMA(Symbol(), TimeFrame, Gi_88, 0, MODE_SMA, PRICE_LOW,
               Li_28 + 1)) / 2.0) / ((Close[Li_16] + Close[Li_16] + High[Li_16] + Low[Li_16] + Open[Li_16]) / 5.0);
         }
      }
   }
   return (0);
}